/********************************************************************************
 *  Copyright 2016-2020 University of Leicester & ARM Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/

#ifndef _LIBRARY_FN_H_
#define _LIBRARY_FN_H_

/*******************************************************************************
 * Add all the public functions that are exported from this library to this    *
 * header file.                                                                *
 ******************************************************************************/

extern void function01 (void);
extern void function02 (void);
extern int fitness_function_init_config(FIT_FN_T*);
extern int fitness_function_startup(FIT_FN_T);
extern int fitness_function_teardown(FIT_FN_T);
extern int payload_init_config(PL_T*);
extern int payload_startup(PL_T);
extern int payload_teardown(PL_T);
extern int sbst_algo_init_config(ALG_T*);
extern int sbst_algo_init_statespace_and_randomseed(ALG_T, PL_T, FIT_FN_T);
extern int sbst_algo_iterate_statespace(ALG_T, PL_T, FIT_FN_T);
extern int sbst_algo_teardown(ALG_T, PL_T, FIT_FN_T);

#endif