#    Copyright 2016-2020 University of Leicester & Arm Limited
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
library(tidyverse)
cat("Reading SBST post processed file for plotting ...")
#Set the correct path first
setwd('~/path/to/file/location')
data_set01=read.csv("AreaUnderCurve_Plots.csv",header=T)
data_set02=read.csv("data_stall_cycles.csv",header=T)
data_set03=read.csv("energy.csv",header=T)

data_set_paper02_01=read.csv("AreaUnderCurve.csv",header=T)
data_set_paper02_02=read.csv("Comparison-boxplot.csv",header=T)
data_set_paper02_03=read.csv("Gain.csv",header=T)



boxplot(data_set01,main="Area Under Curve Comparison", ylab="auc")

boxplot(data_set02,main="Data Stall Cycle Comparison", ylab="data stall cycles")

boxplot(data_set03,main="Energy Comparison", ylab="energy (mW)")




boxplot(data_set_paper02_01,main="Area Under Curve comparison", ylab="auc", names=c("Random-restart Hill-Climbing","Simulated Annealing"))

boxplot(data_set_paper02_02,main="Best Scores Comparison", ylab="data stall cycles", names=c("Simple Hill-Climbing","Random-restart Hill-Climbing","Simulated Annealing"))

boxplot(data_set_paper02_03,main="Score gain comparison", ylab="Gain %", names=c("Simple Hill-Climbing","Random-restart Hill-Climbing","Simulated Annealing"))



AUC_SPEA2 =  quantile(data_set01$SPEA2,na.rm=TRUE)

AUC_SA.PMU =  quantile(data_set01$SA.PMU,na.rm=TRUE)

AUC_SA.Energy =  quantile(data_set01$SA.Energy,na.rm=TRUE)

PMU_SPEA2 =  quantile(data_set02$SPEA2,na.rm=TRUE)

PMU_SA.PMU =  quantile(data_set02$SA.PMU,na.rm=TRUE)

PMU_SA.Energy =  quantile(data_set02$SA.Energy,na.rm=TRUE)

HWMON_SPEA2 =  quantile(data_set03$SPEA2,na.rm=TRUE)

HWMON_SA.PMU =  quantile(data_set03$SA.PMU,na.rm=TRUE)

HWMON_SA.Energy =  quantile(data_set03$SA.Energy,na.rm=TRUE)

AUC_RRHC_PAPER02 = quantile(data_set_paper02_01$Random.restart.Hill.Climbing,na.rm=TRUE)

AUC_SA_PAPER02 = quantile(data_set_paper02_01$Simulated.Annealing,na.rm=TRUE)

GAIN_HC = quantile(data_set_paper02_03$Simple.Hill.Climbing,na.rm=TRUE)

GAIN_RRHC = quantile(data_set_paper02_03$Random.restart.Hill.Climbing,na.rm=TRUE)

GAIN_SA = quantile(data_set_paper02_03$Simulated.Annealing,na.rm=TRUE)

PERF_HC = quantile(data_set_paper02_02$Simple.Hill.Climbing,na.rm=TRUE)

PERF_RRHC = quantile(data_set_paper02_02$Random.restart.Hill.Climbing,na.rm=TRUE)

PERF_SA = quantile(data_set_paper02_02$Simulated.Annealing,na.rm=TRUE)
