/********************************************************************************
 *  Copyright 2016-2020 University of Leicester & Arm Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/

#ifndef _SBST_ADAPTOR_H_
#define _SBST_ADAPTOR_H_

/*common.h rolls up all the common header definitions from each subcomponent
  hence including that alone here is what is expected*/
#include "../../../ontargettestdriver/common/common.h"

/*--------------This is from sbst_hc compilation unit----------------*/

extern CFG_SECTION_T target_config[];
extern ERROR_MAP_T error_map[];
extern int hc_restart_count;
extern int sa_temp_iterations;
extern int sa_max_subopt_count;
extern int sa_composite_temp_iterations;
extern int sa_composite_max_subopt_count;

extern int initialise_hc_rdm_restart_setup(PL_T, FIT_FN_T);
extern int iterate_hc_rdm_restart_statespace(PL_T, FIT_FN_T);

extern int initialise_sa_setup(PL_T, FIT_FN_T);
extern int iterate_sa_statespace(PL_T, FIT_FN_T);

/*--------------End of sbst_hc compilation unit----------------------*/

#endif