/********************************************************************************
 *  Copyright 2016-2020 University of Leicester & Arm Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/

#ifndef _SBST_COMMON_H_
#define _SBST_COMMON_H_

/*Include all common headers in this block*/
#include "sbst_hc_common.h"
#include "sbst_spea2_common.h"

/*Supported sbst algorithm variants*/
typedef enum _sbst_algo_type {HILLCLIMB_RDM_RESTART,SIMANNEAL_BASIC,SIMANNEAL_COMPOSITE,SPEA_2,INVALID_ALG} ALG_T;

typedef enum _eval_scope_type {NEXTGEN_ONLY,CURRENT_ONLY,CURRENT_AND_BEST} EVAL_SCOPE_T;

#endif