/********************************************************************************
 *  Copyright 2018-2020 University of Leicester & Arm Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/

#ifndef _SBST_GENERIC_H_
#define _SBST_GENERIC_H_

/*common.h rolls up all the common header definitions from each subcomponent
  hence including that alone here is what is expected*/
#include "../../../ontargettestdriver/common/common.h"

static long generate_rand_row(void);
static long generate_rand_col(void);
static int evaluate_current_node(EVAL_SCOPE_T, FIT_FN_T);


int determine_rows_cols(long long);
int populate_node(int);
int populate_population_node(int);
int clear_computed_scores(EVAL_SCOPE_T);
int sbst_ccitest_iterator(FIT_FN_T);
int report_ccitest_fitness_function(int, FIT_FN_T);
int generate_initial_seed(PL_T, int, FIT_FN_T);
int generate_initial_population(PL_T, int, FIT_FN_T);
int evaluate_population_nodes(EVAL_SCOPE_T, FIT_FN_T, int);



extern PAYLOAD_T current_node;
extern PAYLOAD_T best_node;
extern PAYLOAD_T next_gen[];
extern PAYLOAD_T pop[];
extern PAYLOAD_T pop_nextgen[];
extern int pl_rows_max;
extern int pl_cols_max;
extern int perf_counters;
extern GRID_POS_T cci_mem_rdwr_payload[];
extern int rows;
extern int cols;
extern long long pl_size;
extern mqd_t mqd_singleobj_ff;
extern mqd_t mqd_pmu_ff;
extern mqd_t mqd_hwmon_ff;
extern int dg_thread_count;
extern int do_thread_count;
extern mqd_t mqd_wr[];
extern mqd_t mqd_rd[];
extern int stat_token_pmu;
extern int stat_token_hwmon;
extern char output_file_pmu[];
extern char output_file_hwmon[];
extern int dat_process_done_pmu;
extern int dat_process_done_hwmon;
extern int iterator;
extern ERROR_MAP_T error_map[];
extern int perf_monitor_duration;




#endif