/********************************************************************************
 *  Copyright 2020 University of Leicester & Arm Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/

#ifndef _SBST_SA_H_
#define _SBST_SA_H_

/*common.h rolls up all the common header definitions from each subcomponent
  hence including that alone here is what is expected*/
#include "../../../ontargettestdriver/common/common.h"


//static int generate_initial_seed(PL_T, int);
//static int evaluate_current_node(EVAL_SCOPE_T);
//static int populate_node (int);
//static int clear_computed_scores (EVAL_SCOPE_T);
//static int generate_next_nodes(void);
//static int evaluate_and_select_next_gen_nodes(void);
//static int sbst_hc_ccitest_iterator(void);
//static int determine_rows_cols(long long);
//static long generate_rand_row(void);
//static long generate_rand_col(void);

int initialise_sa_composite_setup(PL_T, FIT_FN_T);
int iterate_sa_composite_statespace(PL_T, FIT_FN_T);

extern int populate_node(int);
extern int clear_computed_scores(EVAL_SCOPE_T);
extern int determine_rows_cols(long long);
extern int generate_initial_seed(PL_T, int, FIT_FN_T);
//extern int evaluate_current_node(EVAL_SCOPE_T);
extern int generate_next_nodes(void);
extern int sbst_ccitest_iterator(FIT_FN_T fitness_fn);
extern int report_ccitest_fitness_function(int, FIT_FN_T);



extern int reset_to_init_state(void);
extern void set_barriers(void);
//extern int report_pmu_fitness_function(int);

extern PAYLOAD_T current_node;
extern PAYLOAD_T best_node;
extern PAYLOAD_T next_gen[];
extern int pl_rows_max;
extern int pl_cols_max;
//extern int stat_token;
extern int stat_token_pmu;
extern int stat_token_hwmon;
extern int perf_counters;
extern int data_process_done;
extern int dg_thread_count;
extern int do_thread_count;
extern mqd_t mqd_wr[];
extern mqd_t mqd_rd[];
extern mqd_t mqd_singleobj_ff;
extern mqd_t mqd_pmu_ff;
extern mqd_t mqd_hwmon_ff;
extern CPU_TOP_T cpu_topology;
extern int iterator;
extern ERROR_MAP_T error_map[];
extern int dat_process_done;
extern char report_singleobj_name[];
extern char report_shadowobj_name[];
extern char report_composite_name[];
extern int dat_process_done_pmu;
extern int dat_process_done_hwmon;
//extern char output_file[];
extern char output_file_pmu[];
extern char output_file_hwmon[];
extern long long pl_size;
extern GRID_POS_T cci_mem_rdwr_payload[];
extern int perf_max_counters;
extern int rows;
extern int cols;
extern int perf_monitor_duration;
extern int node_id;
extern ACTORPROFILE_T actor_profile;
extern CONSTRAINT_T sparcity_constraint;
extern int individual_index;
extern time_t finish_time;

#endif
