/********************************************************************************
 *  Copyright 2018-2020 University of Leicester & Arm Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/

#ifndef _SBST_SPEA2_H_
#define _SBST_SPEA2_H_

/*common.h rolls up all the common header definitions from each subcomponent
  hence including that alone here is what is expected*/
#include "../../../ontargettestdriver/common/common.h"

static int check_for_mutation(void);
static int check_for_crossover(void);
static int generate_rand_crossover_point(void);
static int generate_rand_matingpool_index(void);
static int generate_rand_archive_index(void);
static int write_population_details(void);
static int a_dominates_b(int, int);
static int do_population_fitness_assignment(void);
static int a_isequalto_b(int, int);
static int sort_candidate_index_on_distance(int);
static int do_compute_density(void);
static double a_distance_from_b(int, int);
static int do_population_distance_compute(void);
static int sort_population_index_on_fitness(void);
static int copy_non_dominates_index(void);
static int truncate_non_dominates(int);
static int do_environmental_selection(void);
static int do_generate_next_population(void);
int initialise_spea2_setup(PL_T, FIT_FN_T);
int iterate_spea2_statespace(PL_T, FIT_FN_T);

extern int generate_next_nodes(void);
extern int populate_node(int);

extern int reset_to_init_state(void);
extern int sbst_ccitest_iterator(FIT_FN_T fitness_fn);
extern int report_ccitest_fitness_function(int, FIT_FN_T);
extern int evaluate_population_nodes(EVAL_SCOPE_T, FIT_FN_T, int);


extern ERROR_MAP_T error_map[];
extern long long pl_size;
extern int pl_rows_max;
extern int pl_cols_max;
extern PAYLOAD_T current_node;
extern PAYLOAD_T pop[];
extern PAYLOAD_T pop_nextgen[];
extern PAYLOAD_T pop_matingpool[];
extern ACTORPROFILE_T actor_profile;
extern CONSTRAINT_T sparcity_constraint;
extern int individual_index;
extern int perf_monitor_duration;
extern int stat_token_pmu;
extern int stat_token_hwmon;
extern time_t finish_time;


#endif
