/********************************************************************************
 *  Copyright 2016-2020 University of Leicester & Arm Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/
#ifndef _ARM_HWMON_FITNESS_FUNCTION_H_
#define _ARM_HWMON_FITNESS_FUNCTION_H_

#include "../../../ontargettestdriver/common/common.h"

int launch_hwmon_fitness_function (void);
int report_hwmon_fitness_function(int);
static void * record_hwmon_events (void*);
static int process_hwmon_dat_files(int);
int report_pop_based_hwmon_fitness_function(int);
static int process_pop_based_hwmon_dat_files(int);

extern int iterator;
extern int generations;
extern int restart_count;
extern struct mq_attr attr;
extern mqd_t mqd_singleobj_ff;
extern mqd_t mqd_hwmon_ff;
extern char hwmon_cmdline[];
extern char report_hwmon_name[];
extern pthread_t fitness_fn_hwmon_thread;
//extern int stat_token;
extern int stat_token_hwmon;
extern int pl_rows_max;
extern int pl_cols_max;
extern FILE* report_fd;
//extern FILE* report_hwmon_fd;
extern PAYLOAD_T current_node;
extern PAYLOAD_T next_gen[];
extern PAYLOAD_T pop[];
extern int perf_monitor_duration;
extern char output_file[];
extern int dat_process_done;

#endif