/********************************************************************************
 *  Copyright 2016-2020 University of Leicester & Arm Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/
#ifndef _FITNESS_FUNCTION_H_
#define _FITNESS_FUNCTION_H_

/*common.h rolls up all the common header definitions from each subcomponent
  hence including that alone here is what is expected*/
#include "../../../ontargettestdriver/common/common.h"

/*--------------This is from arm_cci_pmu_fitness_function compilation unit----------------*/
extern char perf_cmdline[];
extern int perf_max_counters;
extern CFG_SECTION_T target_config[];
extern struct mq_attr attr;
extern ERROR_MAP_T error_map[];
extern char perf_event_list[][COUNTER_NAME_STR_LEN];
extern int perf_counters;
extern int node_id;
extern char hwmon_cmdline[];
extern char multiobj_pmu_ff[];
extern char multiobj_hwmon_ff[];
extern char report_singleobj_name[];
extern char report_pmu_name[];
extern char report_hwmon_name[];
extern char report_shadowobj_name[];
extern char report_composite_name[];


extern int launch_pmu_fitness_function(void);
extern int report_pmu_fitness_function(int);

extern int launch_hwmon_fitness_function(void);
extern int report_hwmon_fitness_function(int);

extern int launch_multiobj_fitness_function(void);
extern int report_multiobj_fitness_function(int);


/*--------------End of arm_cci_pmu_fitness_function compilation unit----------------------*/


#endif
