#    Copyright 2016-2020 University of Leicester & Arm Limited
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
import os
import re
from sbstauto import config

def process_output_for_plotting_hc(fileinput):

    #First extract the filename to generate the output filename
    #index = fileinput.rfind("/")
    #if -1 != index:
    #    filename = fileinput[index+1:]
    #else:
    #    filename = fileinput

    print(fileinput)

#    _event = "cci_a53_read_data_stall"
    _event = "cci_a57_read_data_stall"

    iteration = 1
    hillclimb = 0
    generation = 0


    try:

            with open("{}/output/{}".format(config.SBSTAUTO_HOME,fileinput),
                  mode="rt") as f_in, \
                open("{}/output/{}.tmp".format(config.SBSTAUTO_HOME, fileinput),
                         mode="wr+t") as f_tmp, \
                open("{}/output/{}.csv".format(config.SBSTAUTO_HOME,fileinput),
                     mode="at") as f_out:
                write_to_tmp = False
                f_out.seek(0)
                f_out.truncate()
                f_out.write("iteration,hill_climbing,generation,data_stall_cycles\n")

                for line in iter(f_in):

                    if iteration == 1:
                        f_tmp.seek(0)
                        f_tmp.truncate()
                    if -1 != line.find("[-1]-token0"):
                        write_to_tmp = False
                        generation = 0
                        hillclimb+=1
                        iteration = 1
                    if -1 != line.find("^^^^Current_node -> pl_size"):
                        generation+=1
                    if (-1 != line.find("^^^^Current_node")) or(-1 != line.find("^^^^Nextgen_node")):
                        write_to_tmp = True
                    if write_to_tmp == True:
                        if -1 != line.find("token0"):
                            iteration = 1
                    if -1 != line.find("$$$ Current_node"):
                        generation+=1
                        f_tmp.seek(0)
                        for tmp_line in iter(f_tmp):
                            f_out.write(tmp_line)

                    if -1 != line.find(_event):
                        unpack = line.split(",")
#                        print(line)
                        if len(unpack) == 2:
                            event = unpack[1]
                            if event[:-1] == _event:
                                score = unpack[0]
                                if write_to_tmp:
                                    f_tmp.write("{},{},{},{}\n".format(iteration,hillclimb,generation,score))
                                else:
                                    f_out.write("{},{},{},{}\n".format(iteration, hillclimb, generation, score))
                                iteration+=1
            try:
                os.remove("{}/output/{}.tmp".format(config.SBSTAUTO_HOME, fileinput))
            except OSError as e:
                pass
                #        perfcmdfound = True
                #        cmdline = self._generatePerfCmdLine()
                #        f_out.write("perf_cmdline={}".format("\"" + cmdline + "\"\n"))
                #    if -1 != line.find("max_counters")
                #        perfmaxcntrfound = True
                #        f_out.write("max_counters={}".format(self._MAXCOUNTERS))
                #    else:
                #        if perfcmdfound and perfmaxcntrfound and ".end\n" == line:
                #            f_out.write(line)
                #            return
                #        else:
                #            f_out.write(line)

    except IOError as e:
        print("POSTPROCESSING ERROR: {}".format(str(e)))
        raise e

def process_output_for_plotting_sa(fileinput):

    #First extract the filename to generate the output filename
    #index = fileinput.rfind("/")
    #if -1 != index:
    #    filename = fileinput[index+1:]
    #else:
    #    filename = fileinput

    print(fileinput)

#    _event = "cci_a53_read_data_stall"
    _event = "cci_a57_read_data_stall"

    iteration = 1
    generation = 0


    try:

            with open("{}/output/{}".format(config.SBSTAUTO_HOME,fileinput),
                  mode="rt") as f_in, \
                open("{}/output/{}.tmp".format(config.SBSTAUTO_HOME, fileinput),
                         mode="wr+t") as f_tmp, \
                open("{}/output/{}.csv".format(config.SBSTAUTO_HOME,fileinput),
                     mode="at") as f_out:
                write_to_tmp = False
                f_out.seek(0)
                f_out.truncate()
                f_out.write("iteration,generation,data_stall_cycles\n")

                for line in iter(f_in):

                    if iteration == 1:
                        f_tmp.seek(0)
                        f_tmp.truncate()
                    if -1 != line.find("^^^^Current_node -> pl_size"):
                        generation+=1
                    if (-1 != line.find("^^^^Current_node")) or(-1 != line.find("^^^^Nextgen_node")):
                        write_to_tmp = True
                    if write_to_tmp == True:
                        if -1 != line.find("token0"):
                            iteration = 1
#                    if -1 != line.find("$$$ Current_node"):
                    if -1 != line.find("$$$ NEXTGEN[") and -1 == line.find("[SUB OPTIMAL] [@temperature"):
                        generation+=1
                        f_tmp.seek(0)
                        for tmp_line in iter(f_tmp):
                            f_out.write(tmp_line)

                    if -1 != line.find(_event):
                        unpack = line.split(",")
#                        print(line)
                        if len(unpack) == 2:
                            event = unpack[1]
                            if event[:-1] == _event:
                                score = unpack[0]
                                if write_to_tmp:
                                    f_tmp.write("{},{},{}\n".format(iteration,generation,score))
                                else:
                                    f_out.write("{},{},{}\n".format(iteration, generation, score))
                                iteration+=1
            try:
                os.remove("{}/output/{}.tmp".format(config.SBSTAUTO_HOME, fileinput))
            except OSError as e:
                pass
                #        perfcmdfound = True
                #        cmdline = self._generatePerfCmdLine()
                #        f_out.write("perf_cmdline={}".format("\"" + cmdline + "\"\n"))
                #    if -1 != line.find("max_counters")
                #        perfmaxcntrfound = True
                #        f_out.write("max_counters={}".format(self._MAXCOUNTERS))
                #    else:
                #        if perfcmdfound and perfmaxcntrfound and ".end\n" == line:
                #            f_out.write(line)
                #            return
                #        else:
                #            f_out.write(line)

    except IOError as e:
        print("POSTPROCESSING ERROR: {}".format(str(e)))
        raise e

def process_output_for_plotting_randomtest(fileinput):

    #First extract the filename to generate the output filename
    #index = fileinput.rfind("/")
    #if -1 != index:
    #    filename = fileinput[index+1:]
    #else:
    #    filename = fileinput

    print(fileinput)

#    _event = "cci_a53_read_data_stall"
    _event = "cci_a57_read_data_stall"

    iteration = 1
    hillclimb = 0
    generation = 0


    try:

            with open("{}/output/{}".format(config.SBSTAUTO_HOME,fileinput),
                  mode="rt") as f_in, \
                open("{}/output/{}.tmp".format(config.SBSTAUTO_HOME, fileinput),
                         mode="wr+t") as f_tmp, \
                open("{}/output/{}.csv".format(config.SBSTAUTO_HOME,fileinput),
                     mode="at") as f_out:
                write_to_tmp = False
                f_out.seek(0)
                f_out.truncate()
                f_out.write("iteration,hill_climbing,generation,data_stall_cycles\n")

                for line in iter(f_in):

                    if iteration == 1:
                        f_tmp.seek(0)
                        f_tmp.truncate()
                    if -1 != line.find("[-1]-token0"):
                        write_to_tmp = False
                        generation = 0
                        hillclimb+=1
                        iteration = 1
                    if -1 != line.find("^^^^Current_node -> pl_size"):
                        generation+=1
                    if (-1 != line.find("^^^^Current_node")) or(-1 != line.find("^^^^Nextgen_node")):
                        write_to_tmp = True
                    if write_to_tmp == True:
                        if -1 != line.find("token0"):
                            iteration = 1
                    if -1 != line.find("$$$ Current_node"):
                        generation+=1
                        f_tmp.seek(0)
                        for tmp_line in iter(f_tmp):
                            f_out.write(tmp_line)

                    if -1 != line.find(_event):
                        unpack = line.split(",")
#                        print(line)
                        if len(unpack) == 2:
                            event = unpack[1]
                            if event[:-1] == _event:
                                score = unpack[0]
                                if write_to_tmp:
                                    f_tmp.write("{},{},{},{}\n".format(iteration,hillclimb,generation,score))
                                else:
                                    f_out.write("{},{},{},{}\n".format(iteration, hillclimb, generation, score))
                                iteration+=1
            try:
                os.remove("{}/output/{}.tmp".format(config.SBSTAUTO_HOME, fileinput))
            except OSError as e:
                pass
                #        perfcmdfound = True
                #        cmdline = self._generatePerfCmdLine()
                #        f_out.write("perf_cmdline={}".format("\"" + cmdline + "\"\n"))
                #    if -1 != line.find("max_counters")
                #        perfmaxcntrfound = True
                #        f_out.write("max_counters={}".format(self._MAXCOUNTERS))
                #    else:
                #        if perfcmdfound and perfmaxcntrfound and ".end\n" == line:
                #            f_out.write(line)
                #            return
                #        else:
                #            f_out.write(line)

    except IOError as e:
        print("POSTPROCESSING ERROR: {}".format(str(e)))
        raise e

def process_output_for_plotting_sa_with_shadow_ff(fileinput,shadowfileinput):

    print(fileinput)
    print(shadowfileinput)

    _event = "cci_a57_read_data_stall"
    _shadowevent = "system_power"

#    _event = "system_power"
#    _shadowevent = "cci_a57_read_data_stall"

    iteration = 1
    generation = 0
    iterator_index = 0
    energy = 0

    try:

        with open("{}/output/{}".format(config.SBSTAUTO_HOME, fileinput),
                  mode="rt") as f_in, \
                open("{}/output/{}".format(config.SBSTAUTO_HOME, shadowfileinput),
                     mode="rt") as f_in_shdw, \
                open("{}/output/{}.tmp".format(config.SBSTAUTO_HOME, fileinput),
                     mode="wr+t") as f_tmp, \
                open("{}/output/{}.csv".format(config.SBSTAUTO_HOME, fileinput),
                     mode="at") as f_out:
            write_to_tmp = False
            f_out.seek(0)
            f_out.truncate()
            f_out.write("iteration,generation,data_stall_cycles,energy\n")
#            f_out.write("iteration,generation,energy,data_stall_cycles\n")

            for line in iter(f_in):

                if -1 != line.find("[Iter"):
                    extract = line.split("_")
                    unpack = extract[0].split("r")
                    iterator_index =   unpack[1]


                if iteration == 1:
                    f_tmp.seek(0)
                    f_tmp.truncate()
                if -1 != line.find("^^^^Current_node -> pl_size"):
                    generation += 1
                if (-1 != line.find("^^^^Current_node")) or (-1 != line.find("^^^^Nextgen_node")):
                    write_to_tmp = True
                if write_to_tmp == True:
                    if -1 != line.find("token0"):
                        iteration = 1
                if -1 != line.find("$$$ NEXTGEN[") and -1 == line.find("[SUB OPTIMAL] [@temperature"):
                    generation += 1
                    f_tmp.seek(0)
                    for tmp_line in iter(f_tmp):
                        f_out.write(tmp_line)

                if -1 != line.find(_event):
                    unpack = line.split(",")
                    if len(unpack) == 2:
                        event = unpack[1]
                        if event[:-1] == _event:
                            score = unpack[0]
                            shadow_index = int(iterator_index) + 1
                            f_in_shdw.seek(0)
                            shadow_found = 0;
                            for line_shdw in iter(f_in_shdw):
                                if -1 != line_shdw.find("[Iter{}_".format(shadow_index)):
                                    shadow_found = 1
                                if (1 == shadow_found and -1 != line_shdw.find(_shadowevent)):
                                    extract = line_shdw.split(",")
                                    energy = extract[0]
                                    break

                            if write_to_tmp:
                                f_tmp.write("{},{},{},{}\n".format(iteration, generation, score, energy))
                            else:
                                f_out.write("{},{},{},{}\n".format(iteration, generation, score, energy))
                            iteration += 1
        try:
            os.remove("{}/output/{}.tmp".format(config.SBSTAUTO_HOME, fileinput))
        except OSError as e:
            print("TMP FILE PURGE ERROR: {}".format(str(e)))
            raise e

    except IOError as e:
        print("POSTPROCESSING ERROR: {}".format(str(e)))
        raise e


def process_output_for_plotting_spea2(fileinput):

    print(fileinput)


    non_dom_solution = 0
    generation = 0
    write_to_file = False


    try:

            with open("{}/output/{}".format(config.SBSTAUTO_HOME,fileinput),
                  mode="rt") as f_in, \
                open("{}/output/{}.csv".format(config.SBSTAUTO_HOME,fileinput),
                     mode="at") as f_out:
                f_out.seek(0)
                f_out.truncate()
                f_out.write("generation,non_dominant_solution,data_stall_cycles,hwmon,assigned_ff\n")

                for line in iter(f_in):

                    if -1 != line.find(">>Generation[{}]<<".format(generation)):
                        print(line)
                    if (-1 != line.find("[Archive Population Members]")):
                        write_to_file = True
                        non_dom_solution+=1
                    if write_to_file == True:

                        match_pmu = re.search(r'((pmu)[[](\d+))',line)
                        match_hwmon = re.search(r'((hwmon)[[](\d+))',line)
                        match_ff = re.search(r'((Fitness)[[](\d+))',line)
                        if match_pmu and match_hwmon and match_ff:
                            pmu_score = match_pmu.group(3);
                            hwmon_score = match_hwmon.group(3);
                            ff_score = match_ff.group(3);
                            f_out.write("{},{},{},{},{}\n".format(generation, non_dom_solution,pmu_score, hwmon_score, ff_score))
                            non_dom_solution+=1
                    if -1 != line.find("~~~~~~~"):
                        non_dom_solution=0
                        generation+=1
                        write_to_file = False

    except IOError as e:
        print("POSTPROCESSING ERROR: {}".format(str(e)))
        raise e


if __name__ == '__main__':
    print('Generate data for plotting\n')
    file_input = "SA_pmu_14hrs_iterintemp_10_maxsubopt_5_tempdegrage_0-8_pmuprimary_experiment_30.txt"
    shadow_file_input = "SA_hwmon_14hrs_iterintemp_10_maxsubopt_5_tempdegrage_0-8_pmuprimary_experiment_30.txt"

    #process_output_for_plotting_hc(file_input)

    #process_output_for_plotting_sa(file_input)
    #    process_output_for_plotting_randomtest(file_input)

    process_output_for_plotting_sa_with_shadow_ff(file_input,shadow_file_input)

    #process_output_for_plotting_spea2(file_input)
