/********************************************************************************
 *  Copyright 2016-2020 University of Leicester & Arm Limited                   *
 *                                                                              *
 *  Licensed under the Apache License, Version 2.0 (the "License");             *
 *  you may not use this file except in compliance with the License.            *
 *  You may obtain a copy of the License at                                     *
 *                                                                              *
 *     http://www.apache.org/licenses/LICENSE-2.0                               *
 *                                                                              *
 *  Unless required by applicable law or agreed to in writing, software         *
 *  distributed under the License is distributed on an "AS IS" BASIS,           *
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.    *
 *  See the License for the specific language governing permissions and         *
 *  limitations under the License.                                              *
 *                                                                              *
 *******************************************************************************/

#ifndef _PAYLOAD_CCI_MEM_OPERATIONS_H_
#define _PAYLOAD_CCI_MEM_OPERATIONS_H_

#include <sys/syscall.h>
#include "../../../ontargettestdriver/common/common.h"

#define SYSFS_STR_LEN 64
#define PL_SIZE_80M (5120*4096)

typedef enum _read_type {PAYLOAD_SIZE_RD} RD_T;
typedef enum _transform_type {PAYLOAD_SIZE} TRFM_T;


static int initialise_memory_pattern(void);
void display_memory_pattern(void);
void set_barriers(void);
static int display_topology_info(void);
static int discover_topology_info(void);
static void * data_generator_main (void*);
int launch_data_generator(void);
static void * data_observer_main (void*);
int launch_data_observer(void);
int launch_ccitest_payload_operations(void);
int shutdown_ccitest_payload_operations(void);

extern int no_of_clusters;
extern struct mq_attr attr;

#endif